﻿using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace ScrollSyncOnResize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            LoadData();

            RegisterEvents();
        }

        void LoadData()
        {
            var data = new List<SomeClass>();

            foreach(var value in Enumerable.Range(0, 100))
            {
                data.Add(new SomeClass(value.ToString(), value.ToString(), value));
            }

            ultraGrid1.DataSource = data;
            ultraGrid2.DataSource = data;
        }

        void RegisterEvents()
        {
            ultraGrid1.AfterRowRegionScroll += (s, e) =>
            {
                ultraGrid2.EventManager.SetEnabled(GridEventIds.AfterRowRegionScroll, false);
                ultraGrid2.DisplayLayout.RowScrollRegions[0].ScrollPosition = e.RowScrollRegion.ScrollPosition;
                ultraGrid2.EventManager.SetEnabled(GridEventIds.AfterRowRegionScroll, true);
            };

            ultraGrid2.AfterRowRegionScroll += (s, e) =>
            {
                ultraGrid1.EventManager.SetEnabled(GridEventIds.AfterRowRegionScroll, false);
                ultraGrid1.DisplayLayout.RowScrollRegions[0].ScrollPosition = e.RowScrollRegion.ScrollPosition;
                ultraGrid1.EventManager.SetEnabled(GridEventIds.AfterRowRegionScroll, true);
            };
        }
    }
}
